<?php
/*******************************************************************************
Copyright (c) 2013 Zsolt Debre, Jonathan Till, Attila Alapi.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met: 

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer. 
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution. 

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*******************************************************************************/


//tested with VM 3.0.0
//set-up for but NOT tested with multiple VAT rates (differing by product)
//tested with volume discount where discount is gross absolute amount
//tested with % item discount (no difference between before and after tax appliaction)
//tested with absoulte amount for dscount but ONLY gross after tax application 

//csatlakozas adatbazishoz
require_once(dirname(__FILE__).'/../configuration.php');

//Rendelések státusza
$order_complete_status = 'C'; //C = Confirmed

$config = new JConfig;

if(!mysql_connect($config->host, $config->user, $config->password))
{
	show_error("DB open: " . mysql_error());
}
if(!mysql_select_db($config->db))
{
	show_error("DB select: " . mysql_error());
}

//if(!mysql_query('SET NAMES utf-8'))
if(!mysql_query('SET CHARACTER SET utf8'))
{
	show_error("Unable to set character set. ".mysql_error());
}


$last_orderhead_timestamp = $_GET['last_orderhead_timestamp'];
$max_orders = $_GET['max_orders'] + 0;
if(!$max_orders)
	$max_orders = 100;

//fizetesi modok egy tombbe (map)
$table_name = $config->dbprefix . "virtuemart_paymentmethods_en_gb"; 
$q = "select virtuemart_paymentmethod_id, payment_name from $table_name ";
$payment_method_map = db_get_map($q);

//szállítási modok egy tombbe (map)
$table_name = $config->dbprefix . "virtuemart_shipmentmethods_en_gb";
$q = "select virtuemart_shipmentmethod_id, shipment_name from $table_name ";
$shipment_method_map = db_get_map($q);
	
$table_name = $config->dbprefix . "virtuemart_orders";
$second_table_name = $config->dbprefix . "virtuemart_currencies";
$q = "select * from $table_name as ORD ";
$q .= "left join $second_table_name as CCY on ORD.order_currency = CCY.virtuemart_currency_id ";
$q .= "where order_status ='$order_complete_status' and virtuemart_order_id > ". ($last_orderhead_timestamp+0) ." order by virtuemart_order_id limit $max_orders";

$res = mysql_query($q);
if(!$res)
	show_error("select order: [$q] " . mysql_error());

	
echo '<'.'?xml version="2.0" encoding="UTF-8" standalone="yes" ?'.'>' . "\n";

echo '<!DOCTYPE ORDERS>';
echo '<ORDERS>';

while($order_ary = mysql_fetch_assoc($res))
{
	show_order($order_ary);
}

echo '</ORDERS>';

function show_order($order)
{
	global $config;
	global $payment_method_map;
    global $shipment_method_map;

	$userid = $order['virtuemart_user_id'];
	$orderid = $order['virtuemart_order_id'];
	
	$table_name = $config->dbprefix . "virtuemart_order_userinfos";
	$second_table_name = $config->dbprefix . "virtuemart_countries";
	$third_table_name = $config->dbprefix . "users";
	$q = "select * from $table_name as USER ";
	$q .= "left join $second_table_name as CTRY on USER.virtuemart_country_id = CTRY.virtuemart_country_id ";
	$q .= "left join $third_table_name as JUSR on USER.virtuemart_user_id = JUSR.id ";
	$q .= "where virtuemart_user_id = $userid and address_type='BT'";
	
	$user = db_get_record($q);
    
	//szállítási címek    
	$table_name = $config->dbprefix . "virtuemart_order_userinfos";
	$second_table_name = $config->dbprefix . "virtuemart_countries";
	$third_table_name = $config->dbprefix . "users";
	$q = "select * from $table_name as USER ";
	$q .= "left join $second_table_name as CTRY on USER.virtuemart_country_id = CTRY.virtuemart_country_id ";
	$q .= "left join $third_table_name as JUSR on USER.virtuemart_user_id = JUSR.id ";
	$q .= "where virtuemart_order_id = $orderid and address_type='ST'";
	
	$user_shipping = db_get_record($q);
	
	$table_name = $config->dbprefix . "virtuemart_order_items";
	$q = "select * from $table_name where virtuemart_order_id = $orderid";
	$items = db_get_records($q);

	$today_str = date('Y-m-d');
	$shipped_date_str = $today_str;

	//fizetesi és szállítási mod
    $payment_method_name = $payment_method_map[$order['virtuemart_paymentmethod_id']];
    $shipment_method_name = $shipment_method_map[$order['virtuemart_shipmentmethod_id']];
	
	if ($user['params'] && $user['params'] != '{}') {
		$p = $user['params'];
		$p = '$p = array'.preg_replace(array('/{/','/}/','/:/'),array('(',')','=>'),$p).';';
		eval($p);
	} else {
		$p = array(0);
	}
	
	?>

		<ORDER>
			<ORDERHEAD_CODE><?php echo $order['virtuemart_order_id'].'-'.$order['order_number']; ?></ORDERHEAD_CODE>
			<ORDERHEAD_TIMESTAMP><?php echo sprintf("%010d", $order['virtuemart_order_id']); ?></ORDERHEAD_TIMESTAMP>
			<ORDERHEAD_PARTNER_CODE><?php echo $order['virtuemart_user_id']; ?></ORDERHEAD_PARTNER_CODE>
			<ORDERHEAD_PARTNER_NAME><?php echo he(strlen($user['company']) ? $user['company'] : $user['last_name'].' '.$user['first_name']); ?></ORDERHEAD_PARTNER_NAME>
			<ORDERHEAD_PARTNER_ZIP><?php echo he($user['zip']); ?></ORDERHEAD_PARTNER_ZIP>
			<ORDERHEAD_PARTNER_CITY><?php echo he($user['city']); ?></ORDERHEAD_PARTNER_CITY>
			<ORDERHEAD_PARTNER_ADDRESS><?php echo he($user['address_1'].' '.$user['address_2']); ?></ORDERHEAD_PARTNER_ADDRESS>
			<ORDERHEAD_PARTNER_TAX_NO><?php if (array_key_exists("adoszam",$user)) { echo $user['adoszam']; } ?></ORDERHEAD_PARTNER_TAX_NO>
			<ORDERHEAD_PARTNER_EU_TAX_NO><?php if (array_key_exists("euadoszam",$user)) { echo $user['euadoszam']; } ?></ORDERHEAD_PARTNER_EU_TAX_NO>
			<ORDERHEAD_PARTNER_COUNTRY_INTERNATIONAL_CODE><?php echo $user['country_2_code']; ?></ORDERHEAD_PARTNER_COUNTRY_INTERNATIONAL_CODE>
			<ORDERHEAD_PARTNER_OTHER_DATA></ORDERHEAD_PARTNER_OTHER_DATA>
			
			<ORDERHEAD_PARTNER_MAIL_IS_SAME><?php echo he(strlen($user_shipping['address_type']) ? 0 : 1); ?></ORDERHEAD_PARTNER_MAIL_IS_SAME>
			<ORDERHEAD_PARTNER_MAIL_NAME><?php echo he(strlen($user_shipping['company']) ? $user_shipping['company'] : $user_shipping['last_name'].' '.$user_shipping['first_name']); ?></ORDERHEAD_PARTNER_MAIL_NAME>
			<ORDERHEAD_PARTNER_MAIL_ZIP><?php echo he($user_shipping['zip']); ?></ORDERHEAD_PARTNER_MAIL_ZIP>
			<ORDERHEAD_PARTNER_MAIL_CITY><?php echo he($user_shipping['city']); ?></ORDERHEAD_PARTNER_MAIL_CITY>
			<ORDERHEAD_PARTNER_MAIL_ADDRESS><?php echo he($user_shipping['address_1'].' '.$user_shipping['address_2']); ?></ORDERHEAD_PARTNER_MAIL_ADDRESS>
			<ORDERHEAD_PARTNER_MAIL_COUNTRY_INTERNATIONAL_CODE><?php echo $user_shipping['country_2_code']; ?></ORDERHEAD_PARTNER_MAIL_COUNTRY_INTERNATIONAL_CODE>				
			
			<ORDERHEAD_PAYMENTMETHOD_CODE><?php echo he($payment_method_name); ?></ORDERHEAD_PAYMENTMETHOD_CODE>
			<ORDERHEAD_PAYMENTMETHOD_NAME><?php echo he($payment_method_name); ?></ORDERHEAD_PAYMENTMETHOD_NAME>
			<ORDERHEAD_DATE_SHIPPED><?php echo $shipped_date_str; ?></ORDERHEAD_DATE_SHIPPED>
			<ORDERHEAD_DATE_PAYMENT_DUE><?php echo $today_str; ?></ORDERHEAD_DATE_PAYMENT_DUE>
			<ORDERHEAD_NO_VAT></ORDERHEAD_NO_VAT>
			<ORDERHEAD_NOVATREASON_CODE></ORDERHEAD_NOVATREASON_CODE>
			<ORDERHEAD_CURRENCY_ABBREVIATION><?php echo $order['currency_code_3']; ?></ORDERHEAD_CURRENCY_ABBREVIATION>
			<ORDERHEAD_SUBJECT>Internetes vásárlás: <?php echo $order['order_number']; ?></ORDERHEAD_SUBJECT>
			<ORDERHEAD_VERIFIED>1</ORDERHEAD_VERIFIED>

<?php
				
				$table_name = $config->dbprefix . "virtuemart_order_calc_rules";
				$q = "select * from $table_name where virtuemart_order_id = $orderid";
				$rules = db_get_records($q);
				
				$DATax['szktg'] = 0;
				$VatTax['szktg'] = 0;
				$voldiscrate = NULL;
				
				foreach($items as $item) {
					$key = $item['virtuemart_order_item_id'];
					$DABTax[$key] = 0;
					$DamtATax[$key] = 0;
					$VatTax[$key] = 0;
				}
				
				foreach($rules as $rule) {
					$key = $rule['virtuemart_order_item_id'];
					$mathopsign = substr($rule['calc_mathop'],0,1);
					$mathoppercent = substr($rule['calc_mathop'],1,1);
					$rate = 0;
					$amt = 0;
					
					print("_____________");
					print_r($rule['calc_kind']);
					
					if ($mathopsign) {
						if ($mathoppercent == '%') {
							$rate = $mathopsign.$rule['calc_value'];
						} else {
							$amt = $mathopsign.$rule['calc_value'];
						}
					}
					
					switch ($rule['calc_kind']) {
					    case 'DATax':
					        if ($mathoppercent == '%') {
					        	$DABTax[$key] = (100+$DABTax[$key])*(100+$rate)/100-100;
					        } else {
					        	$DamtATax[$key] += $amt;
					        }
					        break;
					    case 'DBTax':
					       if ($mathoppercent == '%') {
					        	$DABTax[$key] = (100+$DABTax[$key])*(100+$rate)/100-100;
					        } else {
					        	//not yet functional
					        }
					        break;
					    case 'VatTax':
					        $VatTax[$key] = (100+$VatTax[$key])*(100+$rate)/100-100; // if VM is not set up properly then as in VM multiple VAT rates could apply!
					        break;
					    case 'DATaxRulesBill':
						case 'DBTaxRulesBill':
					        $voldiscrate = $rule['calc_amount']/$order['order_salesPrice'];
						 	break;
						case 'shipment':
					        $VatTax['szktg'] = 0+$rate;
					        break;
					}
					/*echo '/ DABTax '; print_r($DABTax);
					echo '/ DamtATax '; print_r($DamtATax);
					echo '/ VatTax '; print_r($VatTax);
					echo '/ volume discount '.$voldiscrate;
					echo '/ shipping tax rate '.$VatTax['szktg'];*/
				}
				
				
				// if volume discount is present then add row for each unique VAT rate
				if ($voldiscrate) {
					foreach ($items as $item) {
						$key = $item['virtuemart_order_item_id'];	
						$keykedv = 'kedv'.$VatTax[$key];
						if (!(array_key_exists($keykedv,$items))) {
							$items[$keykedv] = array(
								'virtuemart_order_item_id' => $keykedv,
								'virtuemart_product_id' => 'kedv',
								'order_item_name' => 'Mennyiségi kedvezmény',
								'product_final_discounted_price' => 0,
								'product_tax' => 0,
								'product_quantity' => 1,
							);
						}
						
						$VatTax[$keykedv] = $VatTax[$key];
						$items[$keykedv]['product_final_discounted_price'] += 100*$voldiscrate*$item['product_subtotal_with_tax']/(100+$VatTax[$key]);
						
						//echo '/ cumulated net for unique VAT rate '.$items[$keykedv]['product_subtotal_with_tax'];
					}
				}
				
						
				
				//add item for shipping too if present
				$grossshipping = $order['order_shipment']+$order['order_shipment_tax'];
				if($grossshipping > 2.5) {
					$item = array(
						'virtuemart_order_item_id' => 'szktg',
						'virtuemart_product_id' => 'szktg',
						'order_item_name' => 'Szállítási költség - '.$shipment_method_name,
						'product_final_discounted_price' => $order['order_shipment'],
						'product_tax' => $order['order_shipment_tax'],
						'product_quantity' => 1,
					);
					$items[] = $item;
				}
				
			show_orderitems($items,$order,$DABTax,$DamtATax,$VatTax); ?>

		</ORDER>
	<?php
}

function show_orderitems($items,$order,$DABTax,$DamtATax,$VatTax)
{
	global $config;

	if(!$items)
		return;
	
	foreach($items as $item) {
		
		$unit = NULL;;	
		$name = $item['order_item_name'];
		
		if (isset($item['order_item_sku'])) { // add sku to descritpion if available
			$name .= ' ('.$item['order_item_sku'].')';
		}
		
		$key = $item['virtuemart_order_item_id'];
		$id = $item['virtuemart_product_id'];
		
		if (abs($DABTax[$key]) > 0.1) { //is there a product line % discount?
			
			if ($DABTax[$key] < 0) {
				$name .= ' '.(-$DABTax[$key]).' %-os kedvezménnyel';
			} else {
				$name .= ' '.($DABTax[$key]).' %-os felárral'; // shouldn't be this in practice
			}
		}

		if (abs($DamtATax[$key]) > 0.1) { //is there a product line absolute amount discount? (pre-tax application not yet functional)
			
			$curamt =  number_format(abs($DamtATax[$key]), $order['currency_decimal_place'],$order['currency_decimal_symbol'],$order['currency_thousands']);
			$curamt = preg_replace(array('/{number}/','/{symbol}/'),array($curamt,$order['currency_symbol']),$order['currency_positive_style']);
			
			if ($DamtATax[$key] < 0) {
				$name .= ' '.$curamt.' kedvezménnyel';
			} else {
				$name .= ' '.$curamt.' felárral'; // shouldn't be this in practice
			}
		}
		
		if (($id !== 'kedv') && ($id !== 'szktg')) {
			$unit = 'db';
			//$item['product_final_discounted_price'] = 100*$item['product_final_price']/(100+$VatTax[$key]);
			$item['product_final_discounted_price'] = $item['product_discountedPriceWithoutTax'];
		}
		
		$vatcode = 'VAT'.number_format($VatTax[$key],2);
		$vatname = preg_replace('/\./',',',$VatTax[$key]).' %';
			
		//$item = ary_to_utf8($item);
		
		//TODO order item unit / translations / product level discounts
		
?>
			<ORDERITEM>
				<ORDERITEM_CODE><?php echo $order['order_number'].'-'.$item['virtuemart_order_item_id']; ?></ORDERITEM_CODE>
				<ORDERITEM_NAME><?php echo he($name); ?></ORDERITEM_NAME>
				<ORDERITEM_QTY><?php echo $item['product_quantity']; ?></ORDERITEM_QTY>
				<ORDERITEM_UNIT><?php echo $unit; ?></ORDERITEM_UNIT>
				<ORDERITEM_LIST_PRICE><?php echo round($item['product_final_discounted_price'],2); ?></ORDERITEM_LIST_PRICE>
				<ORDERITEM_PRICE><?php echo round($item['product_final_discounted_price'],2); ?></ORDERITEM_PRICE>
				<ORDERITEM_VAT_CODE><?php echo $vatcode; ?></ORDERITEM_VAT_CODE>
				<ORDERITEM_VAT_NAME><?php echo $vatname; ?></ORDERITEM_VAT_NAME>
				<ORDERITEM_VAT_PERCENT><?php echo $VatTax[$key]; ?></ORDERITEM_VAT_PERCENT>
			</ORDERITEM>
<?php

				

	}
}


function he($s)
{
	//return htmlentities($s);
	return $s;
}

function show_error($error_str)
{
	echo($error_str);
	die();
}

function db_get_record($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_record(): [$q] " . mysql_error());
	return mysql_fetch_assoc($res);
}

function db_get_field($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_field(): [$q] " . mysql_error());
	$row = mysql_fetch_row($res);
	if($row == FALSE) return FALSE;
	return $row[0];
}

function db_get_records($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_records [$q] " . mysql_error());
	$ret_ary = array();
	while($ary = mysql_fetch_assoc($res))
	{
		$ret_ary[] = $ary;
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function db_get_map($q)
{
	$res = mysql_query($q);
	if(!$res)
		show_error("db_get_map [$q] " . mysql_error());
	$ret_ary = array();
	while($ary = mysql_fetch_row($res))
	{
		$ret_ary[$ary[0]] = $ary[1];
	}
	if(count($ret_ary))
		return $ret_ary;
	return FALSE;
}

function ary_to_utf8($ary)
{
	$res = array();
	foreach($ary as $k => $v)
	{
		if(!is_array($v))
		{
			$res[$k] = mb_convert_encoding($v, 'UTF-8', 'ISO-8859-2');
		}
		else
		{
			$res[$k] = $v;
		}
	}
	return $res;
}

?>
